GestionMusiques/urls.py
from django.conf.urls import url, include
from django.contrib import admin

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^gestion_musiques/', include('musiques.urls'))
]

musiques/urls.py
from django.conf.urls import url
from django.views.generic import TemplateView
from .views import *
from . import views

app_name = 'musiques'
urlpatterns = [
    url(r'^$', views.home, name="gestion_musiques"),
    url(r'^morceaux/(?P<pk>\d+)$',
        MorceauDetailView.as_view(), name='morceau_detail'),
    url(r'^morceaux/add/$', MorceauCreateView.as_view(),
        name="morceau_form"),
    url(r'^morceaux/delete/(?P<pk>\d+)$', MorceauDelete.as_view(),
        name="morceau_delete"),
    url(r'^morceaux/update/(?P<pk>\d+)$', MorceauUpdate.as_view(),
        name="morceau_update"),
    url(r'^morceaux/$', ListeMorceauView.as_view(), name='morceau_list'),
    url(r'^morceaux/deleteall/$', views.deleteMorceau, name="morceau_deleteall"),

    url(r'^artistes/(?P<pk>\d+)$',
        ArtisteDetailView.as_view(), name='artiste_detail'),
    url(r'^artistes/$', ListeArtisteView.as_view(), name='artiste_list'),
    url(r'^artistes/add/$', ArtisteCreateView.as_view(),
        name="artiste_form"),
    url(r'^artistes/delete/(?P<pk>\d+)$', ArtisteDelete.as_view(),
        name="artiste_delete"),
    url(r'^artistes/update/(?P<pk>\d+)$', ArtisteUpdate.as_view(),
        name="artiste_update"),
    url(r'^artistes/deleteall/$', views.deleteArtiste,
        name="artiste_deleteall")
]

musiques/models.py
from django.db import models
from django.urls import reverse

# Create your models here.


class Artiste(models.Model):
    nom = models.CharField(max_length=64)

    def __str__(self):
        return '{self.nom}'.format(self=self)

    def get_absolute_url(self):
        return reverse("musiques:artiste_detail", args=[self.id])


class Morceau(models.Model):
    titre = models.CharField(max_length=64)
    #artiste = models.CharField(max_length=64)
    date_sortie = models.DateField(null=True)
    artiste = models.ForeignKey(Artiste, on_delete=models.CASCADE, null=True)

    def __str__(self):
        return '{self.titre} ({self.artiste})'.format(self=self)

    def get_absolute_url(self):
        return reverse("musiques:morceau_detail", args=[self.id])

musiques/views.py
from django.shortcuts import render, redirect
from django.forms import ModelForm, Textarea
from django.template import RequestContext
from musiques.models import *
from django import forms
from django.urls import reverse_lazy
from django.http import HttpResponse, HttpResponseRedirect
from django.views.generic import CreateView, DetailView, ListView, DeleteView, UpdateView

# Morceaux #################################################################################


class MorceauCreateView(CreateView):
    '''
     ajout d'un morceau
    '''
    model = Morceau
    fields = ['titre', 'artiste', 'date_sortie']


class ListeMorceauView(ListView):
    '''
    liste des morceaux
    '''
    model = Morceau

    def get_context_data(self, **kwargs):
        context = super(ListeMorceauView, self).get_context_data(**kwargs)
        context["morceaux"] = Morceau.objects.all()
        return context


def morceau_detail(request, pk):
    return HttpResponse('OK')


class MorceauDetailView(DetailView):
    '''
    détail d'un morceau
    '''
    model = Morceau


class MorceauDelete(DeleteView):
    model = Morceau
    success_url = "/gestion_musiques/morceaux"
    # reverse_lazy('morceau_list')


class MorceauUpdate(UpdateView):
    """
    Modification d'un Morceau
    """
    model = Morceau
    fields = ['titre', 'artiste', 'date_sortie']
    template_name_suffix = '_update_form'


def deleteMorceau(request):
    """
    supprime tous les morceaux
    """
    Morceau.objects.all().delete()

    context = {}

    return render(request, 'musiques/morceau_list.html', context)


# Artistes #################################################################################

class ArtisteCreateView(CreateView):
    '''
     ajout d'un artiste
    '''
    model = Artiste
    fields = ['nom']


class ListeArtisteView(ListView):
    '''
    liste des artistes
    '''
    model = Artiste

    def get_context_data(self, **kwargs):
        context = super(ListeArtisteView, self).get_context_data(**kwargs)
        context["artistes"] = Artiste.objects.all()
        return context


def artiste_detail(request, pk):
    return HttpResponse('OK')


class ArtisteDetailView(DetailView):
    '''
    détail d'un artiste
    '''
    model = Artiste


class ArtisteDelete(DeleteView):
    model = Artiste
    success_url = "/gestion_musiques/artistes"


class ArtisteUpdate(UpdateView):
    """
    Modification d'un Artiste
    """
    model = Artiste
    fields = ['nom']
    template_name_suffix = '_update_form'


def home(request):
    return render(request, 'musiques/gestion_musiques.html')


def deleteArtiste(request):
    """
    supprime tous les artistes
    """
    Artiste.objects.all().delete()

    context = {}

    return render(request, 'musiques/artiste_list.html', context)

musiques/templates/musiques/artiste_confirm_delete.html
{% extends 'musiques/base.html' %}

{% block title %} Suppression d'un artiste{% endblock %}

{% block contenu %}
    <form action="" method="post">{% csrf_token %}
        <p>Êtes-vous sûr de vouloir supprimer "{{ object }}"?</p>
        <button class="btn btn-danger" type="submit"><i class="glyphicon glyphicon-remove"></i> Oui </button>
        <a href="{% url 'musiques:artiste_list' %}" class="btn btn-success"><i class="glyphicon glyphicon-chevron-left"></i> Non </a>
    </form>
{% endblock %}

musiques/templates/musiques/artiste_detail.html
{% extends 'musiques/base.html' %}

{% block retour %}
<br/>
<a href="{% url 'musiques:artiste_list' %}">
  <button class="btn btn-default" title="retour"><i class="glyphicon  glyphicon-chevron-left"></i> Artistes </button>
</a>
{% endblock %}

{% block title %} Details Artiste {% endblock %}

{% block contenu %}


    <p><label>Nom</label> : {{ artiste.nom }}</p>
    <p id="listemusiques"><label>Liste des musiques :</label></p>
    <ul>
    {% for morceau in artiste.morceau_set.all|slice:':10' %}
      <li>{{morceau.titre}}</li>
    {% endfor %}
    </ul>
    

    <a href="{% url 'musiques:artiste_update' artiste.pk %}" > <button class="btn btn-warning"><i class="glyphicon glyphicon-pencil"></i> Modifier </button> </a>
    <a href="{% url 'musiques:artiste_delete' artiste.pk %}" > <button class="btn btn-danger"><i class="glyphicon glyphicon-trash"></i> Supprimer </button> </a>
{% endblock %}

musiques/templates/musiques/artiste_form.html
{% extends 'musiques/base.html' %}

{% block title %}Ajout d'un artiste{% endblock %}
{% block contenu %}
   <form action="" method="POST">
       {% csrf_token %}
       <h4> {{ form.nom.label }} {{ form.nom }} </h4>
       <input type="submit" value="Ajouter" class="btn btn-success" title="ajouter"/>
   </form>
{% endblock %}

musiques/templates/musiques/artiste_list.html
{% extends 'musiques/base.html' %}
{% block title %} Liste des artistes{% endblock %}
{% block contenu %}

    <a href="{% url 'musiques:artiste_form' %}">
        <button class="btn btn-primary"> Ajouter artiste </button>
    </a>
    
        <button onclick="confirmDelete()" class="btn btn-danger">
            <a href="{% url 'musiques:artiste_deleteall' %} " id="delall">
                <i class="glyphicon glyphicon-trash"></i> Supprimer tous les artistes 
            </a>
        </button>
    

    <ul class="list-group">
    {% for artiste in artistes %}
        <li class="list-group-item">
            <a href="{% url 'musiques:artiste_detail' artiste.pk %}">{{artiste.nom}}</a>
            <a href="{% url 'musiques:artiste_delete' artiste.pk %}" class="droite"> <button class="btn btn-danger"><i class="glyphicon glyphicon-trash"></i> </button> </a>
            <a href="{% url 'musiques:artiste_update' artiste.pk %}" class="droite"> <button class="btn btn-warning"><i class="glyphicon glyphicon-pencil"></i> </button> </a>
        </li>
    {% endfor %}
    </ul>

    <script>
        function confirmDelete() {
            let conf = confirm("Êtes-vous sûr de vouloir supprimer tous les morceaux ?");
            if(conf) { // oui            
                document.querySelector("#delall").click();
            }
        }
    </script>

    
{% endblock %}

musiques/templates/musiques/artiste_update_form.html
{% extends 'musiques/base.html' %}

{% block title %} Modification d'un artiste {% endblock %}

{% block contenu %}
<form action="" method="post">{% csrf_token %}
    {{ form.as_p }}
    <button class="btn btn-warning" type="submit"><i class="glyphicon glyphicon-pencil"></i> Modifier </button>
    <a href="{% url 'musiques:artiste_list' %}" class="btn btn-success"><i class="glyphicon glyphicon-chevron-left"></i> Annuler </a>
</form>
{% endblock %}

musiques/templates/musiques/base.html
<!DOCTYPE html>
<html lang="fr">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">

    <!-- Optional theme -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap-theme.min.css" integrity="sha384-rHyoN1iRsVXV4nD0JutlnGaslCJuC7uwjduW9SVrLvRYooPp2bWYgmgJQIXwl/Sp" crossorigin="anonymous">
    <title>Music Management</title>
    {% load static %}
    <link rel="stylesheet" href="{% static 'musiques/css/style.css' %}">
    {% block style %}
    {% endblock %}
    
    
    
</head>
    <body>
        <nav class="navbar navbar-inverse navbar-fixed-top">
      <div class="container">
        <div class="navbar-header">
          <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false" aria-controls="navbar">
            <span class="sr-only">Toggle navigation</span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
          </button>
          <a class="lien navbar-brand" href="{% url 'musiques:gestion_musiques' %}"><i class="glyphicon glyphicon-headphones"></i> Music Management</a>
        </div>
        <div id="navbar" class="navbar-collapse collapse">
          <ul class="nav navbar-nav">
            <li class=""><a class="lien" href="{% url 'musiques:morceau_list' %}"><i class="glyphicon glyphicon-music"></i>  Morceaux</a></li>
            <li><a class="lien" href="{% url 'musiques:artiste_list' %}"><i class="glyphicon glyphicon-user"></i>  Artistes</a></li>
          </ul>
        </div><!--/.nav-collapse -->
      </div>
    </nav>

    <div class="jumbotron jumbotron-fluid">
        <div class="container">
            {% block retour %} {% endblock %}

            <h2>{% block title %}{% endblock %}</h2>

            <section>
                {% block contenu %}
                {% endblock %}
            </section>

        </div>
    </div>
    {% block video %}
    {% endblock %}

    
        <footer>

        </footer>
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
    </body>
</html>

musiques/templates/musiques/gestion_musiques.html
{% extends 'musiques/base.html' %}

{% load static %}

{% block style %}
<link rel="stylesheet" href="{% static 'musiques/css/stylehome.css' %}">
{% endblock %}

{% block title %}{% endblock %}
{% block contenu %}

<script>
    document.querySelector('.jumbotron').style.display = "none";
</script>
{% endblock %}

{% block video %}

  <video autoplay loop id="bgvid">
    <source src="{% static 'musiques/video/Beats.mp4' %}" type="video/mp4">
  </video>
  <section id="fondNoir">
    <section>
      <p>MUSIC MANAGEMENT</p>
      <p>THE BEST MUSIC MANAGER</p>
    </section>

  </section>
{% endblock %}



  

musiques/templates/musiques/morceau_confirm_delete.html
{% extends 'musiques/base.html' %}
{% block title %} Suppression d'un morceau{% endblock %}
{% block contenu %}
    <form action="" method="post">{% csrf_token %}
        <p>Êtes-vous sûr de vouloir supprimer "{{ object }}"?</p>
        <button class="btn btn-danger" type="submit"><i class="glyphicon glyphicon-remove"></i> Oui </button>
        <a href="{% url 'musiques:morceau_list' %}" class="btn btn-success"><i class="glyphicon glyphicon-chevron-left"></i> Non </a>
    </form>
{% endblock %}

musiques/templates/musiques/morceau_detail.html
{% extends 'musiques/base.html' %}

{% block retour %}
<br/>
<a href="{% url 'musiques:morceau_list' %}">
  <button class="btn btn-default" title="retour"><i class="glyphicon  glyphicon-chevron-left"></i> Morceaux </button>
</a>
{% endblock %}

{% block title %} Details Morceau{% endblock %}

{% block contenu %}

  <p><label>Titre</label> : {{ object.titre }}</p>
  <p><label>Artiste</label> : {{ object.artiste }}</p>
  <p><label>Date de sortie</label> : {{ object.date_sortie }}</p>

  <a href="{% url 'musiques:morceau_update' morceau.pk %}" > <button class="btn btn-warning"><i class="glyphicon glyphicon-pencil"></i> Modifier </button> </a>
  <a href="{% url 'musiques:morceau_delete' morceau.pk %}" > <button class="btn btn-danger"><i class="glyphicon glyphicon-trash"></i> Supprimer </button> </a>


{% endblock %}

musiques/templates/musiques/morceau_form.html
{% extends 'musiques/base.html' %}

{% block title %}Ajout d'un morceau{% endblock %}
{% block contenu %}
   <form action="" method="POST">
       {% csrf_token %}
       <h4> {{ form.titre.label }} {{ form.titre }} </h4>
       <h4> {{ form.artiste.label }} {{ form.artiste }} <a href="{% url 'musiques:artiste_form' %}"><i class="glyphicon glyphicon-plus-sign"></i></a> </h4>
       <h4> {{ form.date_sortie.label }}  {{ form.date_sortie }} </h4>
       <input type="submit" value="Ajouter" class="btn btn-success" title="ajouter"/>
   </form>
{% endblock %}

musiques/templates/musiques/morceau_list.html
{% extends 'musiques/base.html' %}
{% block title %} Liste des morceaux{% endblock %}
{% block contenu %}

    <a href="{% url 'musiques:morceau_form' %}">
        <button class="btn btn-primary"> Ajouter morceau </button>
    </a>
    
        <button onclick="confirmDelete()" class="btn btn-danger">
            <a href="{% url 'musiques:morceau_deleteall' %}" id="delall">
                <i class="glyphicon glyphicon-trash"></i> Supprimer tous les morceaux
            </a>
        </button>
    

    <ul class="list-group">
    {% for morceau in morceaux %}
        <li class="list-group-item">
            <a href="{% url 'musiques:morceau_detail' morceau.pk %}">{{morceau.titre}} ({{morceau.artiste}}) </a>
            <a href="{% url 'musiques:morceau_delete' morceau.pk %}" class="droite"> <button class="btn btn-danger"><i class="glyphicon glyphicon-trash"></i> </button> </a>
            <a href="{% url 'musiques:morceau_update' morceau.pk %}" class="droite"> <button class="btn btn-warning"><i class="glyphicon glyphicon-pencil"></i> </button> </a>
        </li>
    {% endfor %}
  </ul>


  <script>
    function confirmDelete() {
        let conf = confirm("Êtes-vous sûr de vouloir supprimer tous les morceaux ?");
        if(conf) { // oui            
            document.querySelector("#delall").click();
        }
    }
    </script>

{% endblock %}

musiques/templates/musiques/morceau_update_form.html
{% extends 'musiques/base.html' %}

{% block title %} Modification d'un morceau {% endblock %}

{% block contenu %}
<form action="" method="post">{% csrf_token %}
    {{ form.as_p }}
    <button class="btn btn-warning" type="submit"><i class="glyphicon glyphicon-pencil"></i> Modifier </button>
    <a href="{% url 'musiques:morceau_list' %}" class="btn btn-success"><i class="glyphicon glyphicon-chevron-left"></i> Annuler </a>
</form>
{% endblock %}